From dc5c220e8fc0d605a9c4434b421b9d33960b149c Mon Sep 17 00:00:00 2001
From: rserpent <53250916+rserpent@users.noreply.github.com>
Date: Wed, 16 Oct 2019 15:12:21 +0500
Subject: [PATCH 1/3] dns_nic init
---
dnsapi/dns_nic.sh | 185 ++++++++++++++++++++++++++++++++++++++++++++++
1 file changed, 185 insertions(+)
create mode 100644 dnsapi/dns_nic.sh
diff --git a/dnsapi/dns_nic.sh b/dnsapi/dns_nic.sh
new file mode 100644
index 00000000..277cc2d8
--- /dev/null
+++ b/dnsapi/dns_nic.sh
@@ -0,0 +1,185 @@
+#!/usr/bin/env sh
+
+#
+#NIC_Token="sdfsdfsdfljlbjkljlkjsdfoiwjedfglgkdlfgkfgldfkg"
+#
+#NIC_Username="000000/NIC-D"
+
+#NIC_Password="xxxxxxx"
+
+NIC_Api="https://api.nic.ru"
+
+dns_nic_add() {
+ fulldomain="${1}"
+ txtvalue="${2}"
+
+ NIC_Token="${NIC_Token:-$(_readaccountconf_mutable NIC_Token)}"
+ NIC_Username="${NIC_Username:-$(_readaccountconf_mutable NIC_Username)}"
+ NIC_Password="${NIC_Password:-$(_readaccountconf_mutable NIC_Password)}"
+ if [ -z "$NIC_Token" ] || [ -z "$NIC_Username" ] || [ -z "$NIC_Password" ]; then
+ NIC_Token=""
+ NIC_Username=""
+ NIC_Password=""
+ _err "You must export variables: NIC_Token, NIC_Username and NIC_Password"
+ return 1
+ fi
+
+ _saveaccountconf_mutable NIC_Customer "$NIC_Token"
+ _saveaccountconf_mutable NIC_Username "$NIC_Username"
+ _saveaccountconf_mutable NIC_Password "$NIC_Password"
+
+ if ! _nic_get_authtoken "$NIC_Username" "$NIC_Password" "$NIC_Token"; then
+ _err "get NIC auth token failed"
+ return 1
+ fi
+
+ _debug "First detect the root zone"
+ if ! _get_root "$fulldomain"; then
+ _err "Invalid domain"
+ return 1
+ fi
+
+ _debug _sub_domain "$_sub_domain"
+ _debug _domain "$_domain"
+ _debug _service "$_service"
+
+ _info "Adding record"
+ if ! _nic_rest PUT "services/$_service/zones/$_domain/records" "$_sub_domainTXT$txtvalue"; then
+ _err "Add TXT record error"
+ return 1
+ fi
+
+ if ! _nic_rest POST "services/$_service/zones/$_domain/commit" ""; then
+ return 1
+ fi
+ _info "Added, OK"
+}
+
+dns_nic_rm() {
+ fulldomain="${1}"
+ txtvalue="${2}"
+
+ NIC_Token="${NIC_Token:-$(_readaccountconf_mutable NIC_Token)}"
+ NIC_Username="${NIC_Username:-$(_readaccountconf_mutable NIC_Username)}"
+ NIC_Password="${NIC_Password:-$(_readaccountconf_mutable NIC_Password)}"
+ if [ -z "$NIC_Token" ] || [ -z "$NIC_Username" ] || [ -z "$NIC_Password" ]; then
+ NIC_Token=""
+ NIC_Username=""
+ NIC_Password=""
+ _err "You must export variables: NIC_Token, NIC_Username and NIC_Password"
+ return 1
+ fi
+
+ if ! _nic_get_authtoken "$NIC_Username" "$NIC_Password" "$NIC_Token"; then
+ _err "get NIC auth token failed"
+ return 1
+ fi
+
+ if ! _get_root "$fulldomain"; then
+ _err "Invalid domain"
+ return 1
+ fi
+
+ _debug _sub_domain "$_sub_domain"
+ _debug _domain "$_domain"
+ _debug _service "$_service"
+
+ if ! _nic_rest GET "services/$_service/zones/$_domain/records"; then
+ _err "Get records error"
+ return 1
+ fi
+
+ _domain_id=$(printf "%s" "$response" | grep "$_sub_domain" | grep "$txtvalue" | sed -r "s/.*"; then
+ error=$(printf "%s" "$response" | grep "error code" | sed -r "s/.*(.*)<\/error>/\1/g")
+ _err "Error: $error"
+ return 1
+ fi
+
+ if ! _contains "$response" "success"; then
+ return 1
+ fi
+ _debug2 response "$response"
+ return 0
+}
From e00f0b4cf1df691c4baf0293d49d380bf98b5e94 Mon Sep 17 00:00:00 2001
From: rserpent <53250916+rserpent@users.noreply.github.com>
Date: Wed, 16 Oct 2019 15:31:50 +0500
Subject: [PATCH 2/3] Update dns_nic.sh
---
dnsapi/dns_nic.sh | 2 +-
1 file changed, 1 insertion(+), 1 deletion(-)
diff --git a/dnsapi/dns_nic.sh b/dnsapi/dns_nic.sh
index 277cc2d8..b92d2ac9 100644
--- a/dnsapi/dns_nic.sh
+++ b/dnsapi/dns_nic.sh
@@ -113,7 +113,7 @@ _nic_get_authtoken() {
export _H1="Authorization: Basic $token"
export _H2="Content-Type: application/x-www-form-urlencoded"
- res="$(_post "grant_type=password&username=$username&password=$password&scope=%28GET%7CPUT%7CPOST%7CDELETE%29%3A%2Fdns-master%2F.%2B" "$NIC_Api/oauth/token" "" "POST")"
+ res=$(_post "grant_type=password&username=$username&password=$password&scope=%28GET%7CPUT%7CPOST%7CDELETE%29%3A%2Fdns-master%2F.%2B" "$NIC_Api/oauth/token" "" "POST")
if _contains "$res" "access_token"; then
_auth_token=$(printf "%s" "$res" | cut -d , -f2 | tr -d "\"" | sed "s/access_token://")
_info "Token received"
From ffa5472b31b69cedae6e29bc10edf689176d54a0 Mon Sep 17 00:00:00 2001
From: rserpent <53250916+rserpent@users.noreply.github.com>
Date: Wed, 16 Oct 2019 16:25:38 +0500
Subject: [PATCH 3/3] fix whitespaces
---
dnsapi/dns_nic.sh | 44 ++++++++++++++++++++++----------------------
1 file changed, 22 insertions(+), 22 deletions(-)
diff --git a/dnsapi/dns_nic.sh b/dnsapi/dns_nic.sh
index b92d2ac9..493b05bc 100644
--- a/dnsapi/dns_nic.sh
+++ b/dnsapi/dns_nic.sh
@@ -79,7 +79,7 @@ dns_nic_rm() {
_err "Invalid domain"
return 1
fi
-
+
_debug _sub_domain "$_sub_domain"
_debug _domain "$_domain"
_debug _service "$_service"
@@ -129,28 +129,28 @@ _get_root() {
p=1
if ! _nic_rest GET "zones"; then
- return 1
+ return 1
fi
_all_domains=$(printf "%s" "$response" | grep "idn-name" | sed -r "s/.*idn-name=\"(.*)\" name=.*/\1/g")
_debug2 _all_domains "$_all_domains"
while true; do
- h=$(printf "%s" "$domain" | cut -d . -f "$i"-100)
- _debug h "$h"
+ h=$(printf "%s" "$domain" | cut -d . -f "$i"-100)
+ _debug h "$h"
- if [ -z "$h" ]; then
- return 1
- fi
+ if [ -z "$h" ]; then
+ return 1
+ fi
- if _contains "$_all_domains" "^$h$"; then
- _sub_domain=$(printf "%s" "$domain" | cut -d . -f 1-$p)
- _domain=$h
- _service=$(printf "%s" "$response" | grep "$_domain" | sed -r "s/.*service=\"(.*)\".*$/\1/")
- return 0
- fi
- p="$i"
- i=$(_math "$i" + 1)
+ if _contains "$_all_domains" "^$h$"; then
+ _sub_domain=$(printf "%s" "$domain" | cut -d . -f 1-$p)
+ _domain=$h
+ _service=$(printf "%s" "$response" | grep "$_domain" | sed -r "s/.*service=\"(.*)\".*$/\1/")
+ return 0
+ fi
+ p="$i"
+ i=$(_math "$i" + 1)
done
return 1
}
@@ -165,20 +165,20 @@ _nic_rest() {
export _H2="Authorization: Bearer $_auth_token"
if [ "$m" != "GET" ]; then
- _debug data "$data"
- response=$(_post "$data" "$NIC_Api/dns-master/$ep" "" "$m")
+ _debug data "$data"
+ response=$(_post "$data" "$NIC_Api/dns-master/$ep" "" "$m")
else
- response=$(_get "$NIC_Api/dns-master/$ep")
+ response=$(_get "$NIC_Api/dns-master/$ep")
fi
if _contains "$response" ""; then
- error=$(printf "%s" "$response" | grep "error code" | sed -r "s/.*(.*)<\/error>/\1/g")
- _err "Error: $error"
- return 1
+ error=$(printf "%s" "$response" | grep "error code" | sed -r "s/.*(.*)<\/error>/\1/g")
+ _err "Error: $error"
+ return 1
fi
if ! _contains "$response" "success"; then
- return 1
+ return 1
fi
_debug2 response "$response"
return 0